#include <Keypad.h> //vložíme si knihovnu Keypad

const byte ROWS = 4; //řádky
const byte COLS = 3; //sloupce

char hexaKeys[ROWS][COLS] = {  //3D pole s klávesami, jak jsou 
  {'1','2','3'},  //první řádek klávesnice
  {'4','5','6'} ,  //druhý řádek  
  {'7','8','9'},  //třetí
  {'A','0','B'}   //a čtvrtej
};              

byte rowPins[ROWS] = {30,31,32,33}; //piny řádků, dodržujte pořadí odshora dolu, aby 3D pole bylo takové jaká je klávesnice
byte colPins[COLS] = {40,41,42};    //piny sloupců, pamatujte na zleva doprava

Keypad klavesnice = Keypad(makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS);   
//vytvoření objektu klávesnice          znaky |pin řádky|p.sloupce|řádků|sloupců

//vše před tímto řádkem se zabývá jen deklarací a nastavením klávesnice
//nadruhou stranu nás už ale nic zajímat nemusí, jen budeme brát stisknuté klávesy

int piezo = 53; //zase piezo, protože co by to bylo za klávesnici kdyby nepípala
String vstup; //do toho stringu si budeme ukládat vstup z klávesnice
String heslo = "1379"; //a v tomto stringu je uloženo heslo potřebné v přepnutí pinu
int rele = 13; //relé na pinu 13...


void setup()
{
  Serial.begin(9600);
  Serial.println("Kodem ovladany pin");  //aby jsme věděli, co je v Arduinu nahráno
  pinMode(rele, OUTPUT); //výstupní pin pro relé...
}

void loop()
{
  char stisknutyznak = klavesnice.getKey();
  if(stisknutyznak)
  {
    tone(piezo, 1200, 80); //pípneme si...
    if(stisknutyznak == 'A') //když se zmáčkne A, pro zapnutí. Všimněte si, že zde není "A", ale 'A'!Dvojité uvozovky jsou špatně, toto je znak, nikoli text
    {
      if(vstup.endsWith(heslo)) //pokud vstup končí heslem...
      {
        digitalWrite(rele, HIGH);  //pusť proud do relé
        vstup = "";  // yresetuj vstup
        tone(piezo, 2400, 1000); //a úspěšné pípnutí
      }
      else //a pokud nekončí heslem
      {
        vstup =""; //zase vyresetuj vstup
        tone(piezo, 500, 1000); //a neúspěšné pípání
      }
    }
    else if(stisknutyznak == 'B') //když se zmáčkne B pro vypnutí
    {
      if(vstup.endsWith(heslo)) //pokud vstup končí heslem...
      {
        digitalWrite(rele, LOW);  //vypni proud do relé
        vstup = "";  //vyresetuj vstup
        tone(piezo, 2400, 1000); //a úspěšné pípnutí
      }
      else //a pokud nekončí heslem
      {
        vstup =""; //zase vyresetuj vstup
        tone(piezo, 500, 1000); //a neúspěšné pípání
      }
    }
    else //pokud není ani A ani B
    {
      vstup += stisknutyznak; //připojíme na konec vstupu stisknutý znak
    }
  }
}













