#include <Keypad.h> //vložíme si knihovnu Keypad

const byte ROWS = 4; //řádky
const byte COLS = 3; //sloupce

char hexaKeys[ROWS][COLS] = {  //3D pole s klávesami, jak jsou 
{'1','2','3'},  //první řádek klávesnice
{'4','5','6'},  //druhý řádek  
{'7','8','9'},  //třetí
{'A','0','B'}   //a čtvrtej
};              

byte rowPins[ROWS] = {30,31,32,33}; //piny řádků, dodržujte pořadí odshora dolu, aby 3D pole bylo takové jaká je klávesnice
byte colPins[COLS] = {40,41,42};    //piny sloupců, pamatujte na zleva doprava

Keypad klavesnice = Keypad(makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS);   
//vytvoření objektu klávesnice          znaky |pin řádky|p.sloupce|řádků|sloupců

//vše před tímto řádkem se zabývá jen deklarací a nastavením klávesnice
//nadruhou stranu nás už ale nic zajímat nemusí, jen budeme brát stisknuté klávesy

int piezo = 53; //zase piezo, protože co by to bylo za klávesnici kdyby nepípala

void setup()
{
  Serial.begin(9600);
  Serial.println("Odesilani stisknutych klaves na seriovou linku")  //aby jsme věděli, co je v Arduinu nahráno
}

void loop()
{

  char stisknutyznak = klavesnice.getKey(); /*Vytvoří novou proměnnou stisknutyznak typu char(jeden znak),
  do které uloží znak ze stisknuzté klávesy. Není potřeba jí nulovat, protože po odeslání znaku se hned znovu
 do ní načte nový znak, ale pokud nebude na klávesnici nic zmáčknuto, tak zůstane prázdná. */ 
  
  if(stisknutyznak) //zjiszíme, jestli v proměnné něco je, abychom neposílali prázdné řádky
  {
    Serial.println(stisknutyznak); //odešleme po sériové lince    
    tone(piezo, 1200, 80); //a co bvy to bylo za klávesnici, kdyby nepípala při stisknutí klávesy
     //tón po dobu 80 milisekund s frekvencí 1200 hertzů mi přišel nejlepší
  
  }
}
  
